/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumChestCardiacSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_CardiacProceduralStateValues;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_CardiacProceduralStateValues;


/**
 * This class represents CardiacProceduralStateValues_CID3101
 */
public class CardiacProceduralStateValues_CID3101 {
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;
	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	
	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * Instantiates a new CardiacProceduralStateValues_CID3101 Template 
	 */
	public CardiacProceduralStateValues_CID3101()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}

	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumCardiacProceduralStateValues Object of EnumCM_CardiacProceduralStateValues represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_CardiacProceduralStateValues enumCardiacProceduralStateValues)
	{
		switch(enumCardiacProceduralStateValues)
		{
		case RESTING_STATE: this.strCodeValue =EnumCV_CardiacProceduralStateValues.RESTING_STATE_F_01604.getValue(); break;
		case CARDIAC_STRESS_STATE: this.strCodeValue =EnumCV_CardiacProceduralStateValues.CARDIAC_STRESS_STATE_F_05019.getValue(); break;
		case REINJECTION_STATE: this.strCodeValue =EnumCV_CardiacProceduralStateValues.REINJECTION_STATE_109092.getValue(); break;
		case REDISTRIBUTION_STATE: this.strCodeValue =EnumCV_CardiacProceduralStateValues.REDISTRIBUTION_STATE_109093.getValue(); break;
		case DELAYED_REDISTRIBUTION_STATE: this.strCodeValue =EnumCV_CardiacProceduralStateValues.DELAYED_REDISTRIBUTION_STATE_109094.getValue(); break;
		}
	}
	
	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumCardiacProceduralStateValues Object of EnumCM_CardiacProceduralStateValues represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_CardiacProceduralStateValues enumCardiacProceduralStateValues)
	{
		switch(enumCardiacProceduralStateValues)
		{
		case RESTING_STATE : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.RESTING_STATE.getSNOMEDCTID(); break;
		case CARDIAC_STRESS_STATE : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.CARDIAC_STRESS_STATE.getSNOMEDCTID(); break;
		}
	}

	/**
	 * Sets the value for CardiacProceduralStateValues
	 * @param enumCardiacProceduralStateValues Object of EnumCM_CardiacProceduralStateValues.
	 */
	public void setCardiacProceduralStateValues(EnumCM_CardiacProceduralStateValues enumCardiacProceduralStateValues)
	{
		this.strCodeMeaning = enumCardiacProceduralStateValues.getValue();
		if(strCodeMeaning.equalsIgnoreCase(EnumCM_CardiacProceduralStateValues.RESTING_STATE.getValue())||
			strCodeMeaning.equalsIgnoreCase(EnumCM_CardiacProceduralStateValues.CARDIAC_STRESS_STATE.getValue()))
		{
			this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		}
		else
			this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.DCM.getValue();
		
		setCodeValue(enumCardiacProceduralStateValues);
		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumCardiacProceduralStateValues);
	}
}
